#include <Servo.h>	// Include Servo.h library to connect with servos by PWM protocol

#define X_DEGREES 60	// Define two constants used in leg's control equations
#define B 90
#define MIN_DISTANCE 1740	// Define the lowest distance value

Servo servo[6][2];
const int pingPin = 22;	// Ultrasonic sensor's pin number
const int adjustX[] = {89,41,89,39,63,49};	// Values for which the horiziontal servos are in the middle position
const int adjustY[] = {79,89,99,84,89,87};	// Values for which the vertical servos are in the middle position
long time;
long time1;
int wait;
int Pin = 25;	// First servo's pin number
int aux;	// Variable used to calculate vertical servo's values
int xAngle[6];	// Array that stores horizontal servo's values
int yAngle[6];	// Array that stores vertical servo's values
int index1[6] = {-15,-5,5,15,5,-5};	// Starting horizontal position values
boolean encreasing[6] = {1,0,0,0,1,1};	// Starting direction values

void setup()	// Setup function: it will be executed once on start
{
	for(int i=0; i<6; i++)	// Attaching each servo to his pin
	{
		Pin = Pin+2;
		servo[i][0].attach(Pin);
		Pin = Pin+2;
		servo[i][1].attach(Pin);
	}
	delay(20);	// Waiting 20 milliseconds. Servos wants a PWM signal at this frequency to work properly
}

void loop()	// Loop function: it will be executed until turnig off
{
	time = measure();	// Recording into "time" variable the value returned from "measure()"

	if(time<MIN_DISTANCE && encreasing[0]==1 && encreasing[1]==1 && encreasing[2]==1) // ROTATION GAIT
	{
		for(int j=-15; j<=15; j++) // Move the first group of legs
		{
			for(int i=0; i<3; i++)
			{
				servo[i][0].write(j*X_DEGREES/(-30)+adjustX[i]);

				if(i%2!=0)
					servo[i][1].write(adjustY[i]+45);
				else
					servo[i][1].write(adjustY[i]-45);
			}

			for(int i=3; i<6; i++)
			{
				aux = index1[i] * 3;

				if(i%2!=0)
				{
					servo[i][0].write(index1[i]*X_DEGREES/(-30)+adjustX[i]);
					servo[i][1].write(adjustY[i]);
				}
				else
				{
					servo[i][0].write(index1[i]*X_DEGREES/30+adjustX[i]);
					servo[i][1].write(adjustY[i]);
				}
			}
			delay(20);
		}

		for(int j=0; j<50; j++)
		{
			for(int i=0; i<3; i++)
			{
				servo[i][0].write(adjustX[i]-30);
				servo[i][1].write(adjustY[i]);
			}

			for(int i=3; i<6; i++)
			{
				aux = index1[i] * 3;

				if(i%2!=0)
				{
					servo[i][0].write(index1[i]*X_DEGREES/(-30)+adjustX[i]);
					servo[i][1].write(adjustY[i]);
				}
				else
				{
					servo[i][0].write(index1[i]*X_DEGREES/30+adjustX[i]);
					servo[i][1].write(adjustY[i]);
				}
			}
			delay(20);
		}

		for(int j=-15; j<=15; j++) // Move thesecond group of legs
		{
			for(int i=0; i<3; i++)
			{
				servo[i][0].write(adjustX[i]-30);
				servo[i][1].write(adjustY[i]);
			}

			for(int i=3; i<6; i++)
			{
				aux = index1[i] * 3;

				servo[i][0].write(j*X_DEGREES/30+adjustX[i]);

				if(i%2!=0)
					servo[i][1].write(adjustY[i]+45);
				else
					servo[i][1].write(adjustY[i]-45);
			}
			delay(20);
		}

		for(int j=0; j<50; j++)
		{
			for(int i=0; i<3; i++)
			{
				servo[i][0].write(adjustX[i]-30);
				servo[i][1].write(adjustY[i]);
			}

			for(int i=3; i<6; i++)
			{
				servo[i][0].write(adjustX[i]+30);
				servo[i][1].write(adjustY[i]);
			}
			delay(20);
		}

		do	// Rotation until no objecs are detected (when the sensor read a value greater than MIN_DISTANCE)
		{
			for(int j=-15; j<=15; j++)
			{
				for(int i=0; i<3; i++)
				{
					aux = i*3;
					servo[i][0].write(j*X_DEGREES/30+adjustX[i]);
					if(i%2==0)
						servo[i][1].write(adjustY[i]-45);
					else
						servo[i][1].write(adjustY[i]+45);
				}

				for(int i=3; i<6; i++)
				{
					servo[i][0].write(j*X_DEGREES/(-30)+adjustX[i]);
					servo[i][1].write(adjustY[i]);
				}
				delay(20);
			}

			for(int j=0; j<10; j++)
			{
				for(int i=0; i<3; i++)
				{
					servo[i][0].write(adjustX[i]+30);
					servo[i][1].write(adjustY[i]);
				}

				for(int i=3; i<6; i++)
				{
					servo[i][0].write(adjustX[i]-30);
					servo[i][1].write(adjustY[i]);
				}
				delay(20);
			}

			for(int j=-15; j<=15; j++)
			{
				for(int i=0; i<3; i++)
				{
					servo[i][0].write(j*X_DEGREES/(-30)+adjustX[i]);
					servo[i][1].write(adjustY[i]);
				}

				for(int i=3; i<6; i++)
				{
					aux = i*3;
					servo[i][0].write(j*X_DEGREES/30+adjustX[i]);
					if(i%2==0)
						servo[i][1].write(adjustY[i]-45);
					else
						servo[i][1].write(adjustY[i]+45);
				}
				delay(20);
			}

			for(int j=0; j<10; j++)
			{
				for(int i=0; i<3; i++)
				{
					servo[i][0].write(adjustX[i]-30);
					servo[i][1].write(adjustY[i]);
				}

				for(int i=3; i<6; i++)
				{
					servo[i][0].write(adjustX[i]+30);
					servo[i][1].write(adjustY[i]);
				}
				delay(20);
			}
			time1 = measure();
			Serial.print("in: ");
			Serial.print(time1);
		}while(time1<MIN_DISTANCE);

		int index1[6] = {-15,-5,5,15,5,-5};
	}
	else // STRAIGHT WALKING GAIT
	{
		for(int i=0; i<6; i++)
		{
			if(encreasing[i] == 1)	// If the leg is going forward
			{
				aux = index1[i] * 3;

				if(i%2!=0)
				{
					xAngle[i] = index1[i]*X_DEGREES/(-30)+adjustX[i];
					yAngle[i] = (int(sqrt((B*B)-(aux*aux))-77)*45/12)+adjustY[i];
				}
				else
				{
					xAngle[i] = index1[i]*X_DEGREES/30+adjustX[i];
					yAngle[i] = adjustY[i]-(int(sqrt((B*B)-(aux*aux))-77)*45/12);
				}

				index1[i]++;
				if(index1[i] > 15)
				{
					encreasing[i] = 0;
					index1[i]--;
				}
			}
			else	// If the leg is pushing bakward
			{
				index1[i]--;

				if(i%2!=0)
				{
					xAngle[i] = index1[i]*X_DEGREES/(-30)+adjustX[i];
					yAngle[i] = adjustY[i];
				}
				else
				{
					xAngle[i] = index1[i]*X_DEGREES/30+adjustX[i];
					yAngle[i] = adjustY[i];
				}

				if(index1[i] <= -15)
				{
					encreasing[i] = 1;
				}
			}
		}
		servoWrite();

		if((time/1000)<=14)
			wait = 14-(time/1000);
		else
			wait = 0;

		delay(wait);
	}
}

long measure()	// Function that measure the distance of the nearest object
{
	long duration, inches, cm;

	pinMode(pingPin, OUTPUT);
	digitalWrite(pingPin, LOW);
	delayMicroseconds(2);
	digitalWrite(pingPin, HIGH);
	delayMicroseconds(5);
	digitalWrite(pingPin, LOW);

	pinMode(pingPin, INPUT);
	duration = pulseIn(pingPin, HIGH);

	return duration;
}

void servoWrite()	// Function that send to the servos the calculated angles
{
	for(int i=0; i<6; i++)
	{
		servo[i][0].write(xAngle[i]);
		servo[i][1].write(yAngle[i]);
	}
}
